/* ----------------------------------------------------- apicloud 公共方法   ----------------------------------------------------- */
//本地存储的变量说明
//ACCESSTOKEN
//VERTICALFZ----竖屏根字体大小
//LANDSCAPEFZ----横屏根字体大小
//USERID-----用户id
//COMPANYID----企业id
//FARMID----农场id
/* ----------------------------------------------------- 可配置全局变量   ----------------------------------------------------- */
var globalObj = {
	updateurl:'',	//APP 更新地址
}
//针对 iphone6 不支持页面切换动画
function animationfn() {
	if(api.deviceModel == "iPhone 6"){
		animationtype = {
			type: 'none',
			duration: 0
		}
	} else {
		animationtype = {
			type: 'push',
			subType: "from_right",
			duration: 300
		}
	}
}
//普通打开window
function openWin(winname,winurl,from,slidBackBool) {
	animationfn();
	if(from) {
		animationtype.subType = "from_left"
	};
	api.openWin({
		name: winname,
		url: winurl,
		bounces: false,
		reload: true,
		slidBackType:'edge',
		slidBackEnabled:slidBackBool==false?false:true,
		rect: {
			x: 0,
			y: 0,
			w: 'auto',
			h: 'auto'
		},
		animation: animationtype
	})
}
//打开普通iframe
function openFrame(framename, frameurl, xval, yval,slidBackBool) {
	animationfn();
	api.openFrame({
		name: framename,
		url: frameurl,
		bounces: false,
		reload: true,
		slidBackEnabled:slidBackBool==false?false:true,
		delay: 0,
		rect: {
			x: xval,
			y: yval,
			w: 'auto',
			h: 'auto'
		},
		animation: {
			type: 'none'
		}
	});
}
//打开带参数的iframe
function openframeparam(framename, frameurl, xval, yval, pageParam,slidBackBool) {
	animationfn();
	api.openFrame({
		name: framename,
		url: frameurl,
		bounces: false,
		reload: true,
		slidBackEnabled:slidBackBool==false?false:true,
		delay: 0,
		pageParam:pageParam,
		rect: {
			x: xval,
			y: yval,
			w: 'auto',
			h: 'auto'
		},
		animation: {
		    type:"push",
		    subType:"from_right"
		}
	});
}
//打开传参页面
function openwinparam(xx, yy, ww, hh, winName, winUrl, pageParam,slidBackBool) {
	animationfn();
	api.openWin({
		name: winName,
		url: winUrl,
		pageParam: pageParam,
		slidBackType:'edge',
		slidBackEnabled:slidBackBool==false?false:true,
		bounces: false,
		reload: true,
		rect: {
			x: xx,
			y: yy,
			w: ww,
			h: hh
		},
		animation: animationtype
	})
}
function closeWin() {
	api.closeWin();
}
//网络改变
function linechange(offlinefn, onlinefn) {
	//完全断网
	api.addEventListener({
		name: 'offline'
	}, function(ret, err) {
		if(api.connectionType == "none") {
			api.hideProgress();
			if(offlinefn) {
				offlinefn();
			} else {
				api.toast({
					msg: "网络链接失败，请稍候重试",
					duration: 3000,
					location: 'middle'
				});
			}
		}
	});
	//网络恢复
	api.addEventListener({
		name: 'online'
	}, function(ret, err) {
		if(onlinefn) {
			onlinefn();
		} else {
			api.toast({
				msg: "网络恢复",
				duration: 3000,
				location: 'middle'
			});
		}
	});
}
//屏蔽ios右扫返回事件
function swiperightnone(){
	api.addEventListener({
		name: 'swiperight'
	}, function(ret, err) {
		return false;
	});
}
//检查更新
function checkUpdate(mandatory){
	mandatory=mandatory|false;
    var mam = api.require('mam');
    if(mandatory){	//显示加载进度框
	    api.showProgress({title: '检查版本中',text: '请稍候...',modal: false});
	    globalObj.updateurl='./update.html';
    }else{
    	globalObj.updateurl='./html/home/update.html';
    }
    mam.checkUpdate(function(ret, err) {
        if(ret){
            var result = ret.result;
            if(mandatory){api.hideProgress();}
            if(result && !result.hasOwnProperty('update')){
            	api.hideProgress();
	            return false;
            }
            if (result.update == true && result.closed == false){	//有最新版本  非强制更新------------
            	$api.setStorage("ISLATESTVERSION",0);
            	if((!$api.getStorage("UPDATEHELP") || ($api.getStorage("UPDATEHELP") && Date.parse(new Date())-$api.getStorage("UPDATEHELP")>=43200000)) || mandatory){
            		//手动检测  有非强制更新版本
					var updatestr ='更新内容：\n'+result.updateTip;
					api.confirm({
						title : '发现新版本V'+result.version,
						msg: updatestr,
						buttons: ['立即更新', '暂不更新']
					},function(ret, err) {
						if(ret.buttonIndex == 1) {
							appinstall(result);
						}else{
							$api.setStorage("UPDATEHELP",Date.parse(new Date()));
						}
					});
            	}
            }else if(result.update == true && result.closed == true){	//有最新版本  强制更新---------
            	//新更新版本 强制更新
            	if(api.systemType == "android") {
					api.alert({
						title : '发现新版本V'+result.version+',需强制更新！',
						msg: '更新内容：\n'+result.updateTip,
						buttons: ['立即更新']
					},function(ret, err) {
						if(ret.buttonIndex == 1) {
							appinstall(result);
						}
					});
				}else if(api.systemType == "ios") {
					api.alert({
						title : '发现新版本V'+result.version+',需强制更新！',
						msg: '更新内容：\n'+result.updateTip,
						buttons: ['立即更新']
					},function(ret, err) {
						if(ret.buttonIndex == 1) {
							appinstall(result);
						}
					});
				}
            	$api.setStorage("ISLATESTVERSION",0);
            }else {		//已经最新版本---------
            	//无更新情况
            	if(mandatory){
            		api.toast({ msg: '当前已是最新版本', duration: 3000, location: 'bottom' });
            	}else{
            		$api.setStorage("ISLATESTVERSION",1);
            		return false;
            	}
            }
        }else{
        	api.hideProgress();
        	//api.alert({msg :'获取版本失败'});
        }
    });
}
//下载安装应用
function appinstall(result){
	//判断设备类型
	if(api.systemType == "android") {
		installfn(result);
	}else if(api.systemType == "ios") {
		api.installApp({
			appUri: result.source
		});
	}
	function installfn(res){
		if(api.connectionType != "wifi"){
			api.confirm({
				title: '温馨提示 ',
				msg: '检测到您当前未处于wifi环境下,是否继续下载 ',
				buttons: ['土豪流量多', '算了']
			}, function(ret, err) {
				if(ret.buttonIndex == 1){
					install(res);
				}else{
					$api.setStorage("UPDATEHELP",Date.parse(new Date()));
				}
			});
		}else{
			install(res);
		}
	}
	function install(result){
		//询问存储权限后 按照
		getFilePermission(function(){
			//打开下载页面
			api.openWin({
				name: 'update',
				url: globalObj.updateurl,
				bounces: false,
				rect: { x: 0, y: 0, w: 'auto', h: 'auto' },
				animation: { type: 'none', duration: 0 },
				slidBackEnabled:true,
				pageParam:{ downurl:result.source }
			})
			api.download({
				url: result.source,
				savePath:'fs://Download/shennongkoudai.apk',
				cache: true,
				report: true
			}, function(ret, err) {
				if(ret && 0 == ret.state) { /* 下载进度 */
					//更新显示进度条
					api.execScript({
						name: 'update',
						script: 'goprogress(' + ret.percent + ')'
					});
				}
				if(ret && 1 == ret.state) { /* 下载完成 */
					api.closeWin({
						name: 'update'
					});
					var savePath = ret.savePath;
					api.installApp({
						appUri: savePath
					});
				}
			});
		})
	}
}
//是否有读写权限
function getFilePermission(nextfn){//请求是否有拍照或者相册权限
	var _this = this;
	var resultList = api.hasPermission({
	    list:['storage']
	});
	if(!resultList || !resultList[0] || !resultList[0].granted){	//没权限
		api.requestPermission({
		    list:['storage'],
		    code:100001
		}, function(ret, err){
		    if(ret.list[0].granted){	//打开了权限
				nextfn && nextfn();
		    }
		});
	}else{
		nextfn && nextfn();
	}
}
//物理返回键 退出应用
function fnRegisterKeyBack(){
	api.addEventListener({
		name: 'keyback'
	}, function(ret, err) {
		if(timeback==0){timeback = Date.parse(new Date());}
		if((timeback - timebackplus) < 3000) {
			api.closeWidget({
				silent: true
			});
		} else {
			api.toast({
				msg: '再按一次退出程序',
				duration: 3000,
				location: 'bottom'
			});
			setTimeout(function(){
				timeback=0;
			},3000)
		}
		timebackplus = timeback;
	})
}

//初始化 时间选择器
/*
	//初始化选择器
	var UIDatePicker = api.require('UIDatePicker');
	initdatepicker({
		module:UIDatePicker,
		domobj:$("p span.datepicker"),	//jq 对象 可以是多个 
		minDate:"1990-01-01 00:00:00",//不做限制则不写该配置
		maxDate:"2030-01-01 00:00:00",//不做限制则不写该配置
		selectedcallback:function(res,domobj){	//选择后回调
			if(res.eventType=="submit"){
				//{"month":12,"year":2018,"eventType":"submit","day":27}
				var daystr='';
				if(domobj.attr("type")=='date'){
					domobj.data("selected",res.year+'-'+res.month+'-'+res.day+" 00:00:00");
					daystr=res.year+'.'+res.month+'.'+res.day;
				}else{
					var minstr=res.minute || '00';
					domobj.data("selected",res.year+'-'+res.month+'-'+res.day+" "+res.hour+":"+minstr+":00");
					daystr=res.year+'.'+res.month+'.'+res.day+" "+res.hour+":"+minstr;
				}
				domobj.html(daystr);
			}
		}
	});
 */
function initdatepicker1(options){
	for(var i=0;i<options.domobj.length;i++){
		(function(obj){
			obj.on('click',function(){
				var timestr='';
				var timetype='date';
				if($(this).html()!=''){
					timestr=$(this).html();
				}
				//2018/1/1
				//2018.1.1 00:00
				//yyyy-MM-dd HH:mm:ss
				if($(this).attr("type")=='date' && timestr.split('/').length==3){
					timestr=timestr.split('/').join('-');
					timestr=timestr+" 00:00:01";
				}
				if($(this).attr("type")=='datetime' && timestr.split('.').length==3){
					timestr=timestr.split('.').join('-');
					timestr=timestr+":01";
				}
				if($(this).data("selected") && $(this).data("selected").indexOf("设置")==-1){
					timestr=$(this).data("selected");
				}
				if($(this).attr("type")=='datetime'){ timetype='dateHourMinute'; }
				console.log(timestr)
				//yyyy-MM-dd HH:mm:ss
				var opts = {
					maxDate:options.maxDate ? options.maxDate:'2068-01-01 00:00:00',
					minDate:options.minDate ? options.minDate:'1932-01-01 00:00:00',
					date:timestr ? timestr:false
				};
				initpicker($(this),timetype,opts);
			})
		})(options.domobj.eq(i))
	}
	function initpicker(domobj,type,opts){
		var remfz=$api.getStorage("VERTICALFZ");
		var activeitemfz=parseInt(0.32*remfz);
		var itemfz=parseInt(0.28*remfz);
		var btnfz=parseInt(0.3*remfz);
		var linefz=parseInt(0.9*remfz);
		var pickeroptions={
			type: type,
			rowHeight: linefz,
			maxDate:opts.maxDate,
			minDate:opts.minDate,
			title: '',
			styles: {
				bg: 'rgba(255,255,255,1)',
				headerViewBackgroundColor: '#f5f5f5',
				lineBackgroundColor: '#E0E0E0',
				item: {
					normal: '#888',
					normalFont: itemfz,
					selected: '#333',
					selectedFont: activeitemfz,
					cancelBtn: {
						cancelButtonTextColor: '#64C3A4',
						cancelButtonText: '取消',
						cancelButtonFont: btnfz
					},
					confirmBtn: {
						confirmButtonTextColor: '#64C3A4',
						confirmButtonText: '确定',
						confirmButtonFont: btnfz
					}
				}
			},
		}
		//设置初始值
		if(opts.date){
			pickeroptions.date=opts.date;
		}
		
		//自定义 属性
		if(options.setoptionsfn){pickeroptions=options.setoptionsfn(pickeroptions);}
		options.module.open(pickeroptions, function(ret, err) {
			if(ret){
				if(options.selectedcallback){options.selectedcallback(ret,domobj);}
				options.module.close();
			}
		});
	}
}

//zyj，点击事件需要自己定义的用下面这个
function initdatepicker(options){
	for(var i=0;i<options.domobj.length;i++){
		(function(obj){
			var timestr='';
			var timetype=obj.attr("type")=="datetime" ? "dateHourMinute":"date";
			//2018/1/1
			//2018.1.1 00:00
			//yyyy-MM-dd HH:mm:ss
			//无论obj.attr("type")值为date还是datetime，data-selected的格式都必须为yyyy-MM-dd HH:mm:ss
			if(obj.data("selected")){
				timestr=obj.data("selected");
				console.log('timestr:'+timestr);
			}
			//yyyy-MM-dd HH:mm:ss
			var opts = {
				maxDate:options.maxDate ? options.maxDate:'2068-01-01 00:00:00',
				minDate:options.minDate ? options.minDate:'1932-01-01 00:00:00',
				date:timestr ? timestr:false,
				cancelColor:options.cancelColor ? options.cancelColor:'#64C3A4',
				cancelText:options.cancelText ? options.cancelText:'取消',
				title:options.title ? options.title:'',
			};
			initpicker(obj,timetype,opts);
		})(options.domobj.eq(i))
	}
	function initpicker(domobj,type,opts){
		var remfz=$api.getStorage("VERTICALFZ");
		var activeitemfz=parseInt(0.32*remfz);
		var itemfz=parseInt(0.28*remfz);
		var btnfz=parseInt(0.3*remfz);
		var linefz=parseInt(0.9*remfz);
		var pickeroptions={
			type: type,
			rowHeight: linefz,
			maxDate:opts.maxDate,
			minDate:opts.minDate,
			title: opts.title,
			styles: {
				bg: 'rgba(255,255,255,1)',
				headerViewBackgroundColor: '#f5f5f5',
				lineBackgroundColor: '#E0E0E0',
				item: {
					normal: '#888',
					normalFont: itemfz,
					selected: '#333',
					selectedFont: activeitemfz,
					cancelBtn: {
						cancelButtonTextColor: opts.cancelColor,
						cancelButtonText: opts.cancelText,
						cancelButtonFont: btnfz
					},
					confirmBtn: {
						confirmButtonTextColor: '#64C3A4',
						confirmButtonText: '确定',
						confirmButtonFont: btnfz
					}
				}
			},
		}
		//设置初始值
		if(opts.date){
			pickeroptions.date=opts.date;
		}
		
		//自定义 属性
		if(options.setoptionsfn){pickeroptions=options.setoptionsfn(pickeroptions);}
		options.module.open(pickeroptions, function(ret, err) {
			if(ret){
				if(options.selectedcallback){options.selectedcallback(ret,domobj);}
				options.module.close();
			}
		});
	}
}

//底部按钮 弹出初始化
/*
	bottombtnfn({
		"redbtn":'红色按钮',
		"btns":['普通按钮一','普通按钮二','普通按钮三'],
		"cancel":'取消',
		"btnscolor":'#64C3A4',
		"selectedfn":function(index){	//选择后 返回按钮从上至下的序号 1开始
			console.log(index);
		},
		"setoptionsfn":function(options){
			return options;
		}
	})
 */
function bottombtnfn(options){
	var redbtn=options.redbtn || '';
	var cancelbtn=options.cancel || '取消';
	var btns=options.btns || [];
	var setoptions={
	    title: '',
	    destructiveTitle: redbtn,
	    buttons: btns,
	    cancelTitle: cancelbtn,
	    style:{
		    layerColor:'rgba(0, 0, 0, 0.4)',	//遮蔽层颜色，仅支持 rgba颜色，默认值：rgba（0, 0, 0, 0.4）
		    itemNormalColor:'#ffffff',    //按钮背景颜色
		    itemPressColor:'#f5f5f5',     //按下按钮背景颜色
		    fontNormalColor:options.btnscolor,    //正常状态文字颜色
		    fontPressColor:'#f5f5f5',     //按下正常状态文字颜色
		    titleFontColor:'#333333'      //标题文字颜色
		}
	};
	if(options.setoptionsfn){setoptions=options.setoptionsfn(setoptions);}	//自定义改样式
	api.actionSheet(setoptions,function(ret, err) {
	    var index = ret.buttonIndex;
	    options.selectedfn(index)
	});
}
/*
var dialogBox = api.require('dialogBox');
initAlertfn(dialogBox,{
	"title":'确定重做任务？',
	"content":'重做后，反馈的图片将被删除。',	//副标题 没有可以不填
	"leftbtn":'我再想想',
	"rightbtn":'重做任务',
	"leftbtncolor":'#999999',
	"rightbtncolor":'#34C6A2',
	"callback":function(result){
		if(result){	//点击右边按钮 回调
			alert('确定后 回调')
		}else{	//点击左边按钮 回调
			//取消后回调
		}
	},
	"setoptionsfn":function(options){
		return options;
	}
});
 */
//初始化 alert弹框
function initAlertfn(dialogbox,options){
	var remfz=$api.getStorage("VERTICALFZ");
	var btnW=parseInt(2.8*remfz);
	var btnH=parseInt(1*remfz);
	var setoptions={
	    texts: { title: options.title, content: options.content, leftBtnTitle: options.leftbtn, rightBtnTitle:options.rightbtn},
	    styles: {
	        bg: '#fff',
	        w: parseInt(5.6*remfz),
	        corner:2,
	        title: { marginT: 20, icon: '', iconSize: 40, titleSize: parseInt(0.36*remfz), titleColor: '#333' },
	        content: { color: '#666', size: parseInt(0.28*remfz) },
	        left: { marginB: 0, marginL: 0, w: btnW, h: btnH, corner: 0, bg: '#fff', color: options.leftbtncolor, size: parseInt(0.3*remfz) },
	        right: { marginB: 0, marginL: 0, w: btnW, h: btnH, corner: 0, bg: '#fff', color: options.rightbtncolor, size: parseInt(0.3*remfz) },
	        horizontalLine:{ color:'rgba(245,245,245,1)', height:1 },
		    verticalLine:{ color:'rgba(245,245,245,1)', width:1 }
	    }
	}
	if(!options.content || options.content==''){
		setoptions.styles.title.marginT=40;
		setoptions.styles.content.marginT=setoptions.styles.content.marginB=10;
	}
	if(options.setoptionsfn){
		setoptions=options.setoptionsfn(setoptions);
	}
	dialogbox.alert(setoptions,function(ret) {
	    if (ret.eventType == 'left' || ret.eventType == 'right') {
	        dialogbox.close({ dialogName: 'alert' });
	        if(ret.eventType == 'right'){
	        	options.callback(true);
	        }else{
	        	options.callback(false);
	        }
	    }
	});
}
/* -----------------------------------------------------  前端 公共方法    ----------------------------------------------------- */
//横竖屏字体大小控制
function setRem(normal) {
	var html = document.querySelector("html");
	if(normal || arguments.length == 0) {
		html.style.fontSize = $api.getStorage("VERTICALFZ") + "px";
	} else {
		html.style.fontSize = $api.getStorage("LANDSCAPEFZ") + "px";
	}
}
setRem(true);
//ajax
/*
 	var postobj=getPost({
		"url":'',
		"params":{},
		"notoken":false,
		"successfn":function(){
			console.log(1)
		},
		"errorself":true
	})
	
	postobj.then(function(err){
		console.log(1)
	},function(err){
		
	})
	
 */
function getPost(obj){
	if(!obj.hasOwnProperty('notoken') || !obj.notoken){obj.notoken=false;}
	if(!obj.hasOwnProperty('errorself') || !obj.errorself){obj.errorself=false;}
	if(!obj.hasOwnProperty('params') || !obj.params){obj.params={};}
	if(!obj.hasOwnProperty('noload') || !obj.noload){obj.noload=false;}
	var postobj={
		type: "POST", 
		contentType: 'application/json;charset=UTF-8',
		url: obj.url,
		data:JSON.stringify(obj.params),
		dataType:"json",
		success:function(res){
			if(res.respCode==0){
				if(obj.successfn){ obj.successfn(res); }
			}else if(res.respCode==404){//企业不存在、农场不存在或权限不足
				api.toast({
					msg:"您的权限无法使用该功能，可联系超级管理员修改权限",
					duration:3000,
					location: 'middle'
				});
				
				setTimeout(function(){
					api.sendEvent({
					    name: 'changeFarm'
					});
					api.closeToWin({
					    name: 'root',
	                    animation:{
					    	type:"none",
						    duration:50   
					    }
					});
				},3000);
			}else if(res.respCode==400){//token 失效 重新登录
				//保存  已有storage
				var STATUSSH=$api.getStorage("STATUSSH");
				var VERTICALFZ=$api.getStorage("VERTICALFZ");
				var LANDSCAPEFZ=$api.getStorage("LANDSCAPEFZ");
				$api.clearStorage();
				$api.setStorage("STATUSSH",STATUSSH);
				$api.setStorage("VERTICALFZ",VERTICALFZ);
				$api.setStorage("LANDSCAPEFZ",LANDSCAPEFZ);
				//打开登录页
				api.sendEvent({
				    name: 'openloginevent'
				});
				api.closeToWin({
				    name: 'root',
                    animation:{
				    	type:"none",
					    duration:50   
				    }
				});
			}else if(res.respCode==600){//服务离线
				api.toast({
					msg:res.respDesc,
					duration: 3000,
					location: 'middle'
				});
			}else{
				if(!obj.errorself){
					api.toast({
						msg: res.respDesc,
						duration: 3000,
						location: 'middle'
					});
				}
			}
		},
		error:function(XMLHttpRequest,textStatus,errorThrown){
			console.log("---------------------------------");
			console.log("ACCESSTOKEN："+$api.getStorage("ACCESSTOKEN"));
			console.log("传参："+JSON.stringify(obj.params));
			console.log("接口："+obj.url);
			console.log("错误返回XMLHttpRequest："+JSON.stringify(XMLHttpRequest));
			console.log("错误返回textStatus："+textStatus);
			console.log("错误返回errorThrown："+JSON.stringify(errorThrown));
			console.log("---------------------------------");
			
			if(textStatus=='timeout'){
				api.toast({
			 		msg:"请求超时",
			 		duration: 3000,
			 		location: 'middle'
			 	});
			 	//$.ajax.abort();	//丢弃原有ajax 
			}else{
				api.toast({
			 		msg:"网络连接失败",
			 		duration: 3000,
			 		location: 'middle'
			 	});
			}
		},
		timeout:30000,
        complete: function () {
        	if(!obj.noload){api.hideProgress();}
        }
	};
	postobj.beforeSend=function(request) {
		if(!obj.notoken){ request.setRequestHeader("accessToken",$api.getStorage("ACCESSTOKEN")); }
		request.setRequestHeader("clientType",2);
		if(!obj.noload){
			api.showProgress({
			    title: '数据加载中...',
			    text: '',
			    modal: false
			});
		}
	};
	return $.ajax(postobj);
}

//打开抽屉侧滑页
function openmainfn(mainUrl,leftUrl,findex,pagetype){
//	api.closeWin({name:"main"});
//	api.closeWin({name:"leftmain"});
	var edgew=parseInt(parseInt(api.winWidth)*0.2);
	var opts = {
		    name:'main',
		    url:mainUrl,
		    slidBackType:'edge',
		    bounces:false,
		    scrollEnabled:true,
		    hScrollBarEnabled:true,
		    slidBackEnabled:false,
		    reload:true,
		    animation:{
		        type: 'none'
		    },
		    leftPane: {
		        name:'leftmain',
		        edge:edgew,
		        url:leftUrl
		    }
		}
		
	if(findex){
		opts.pageParam = {"footTab":findex,"pagetype":pagetype};
	}
	api.openDrawerLayout(opts);
}

/* -----------------------------------------------------  公共 业务方法    ----------------------------------------------------- */

//时间戳处理 	new Date().format("yyyy-MM-dd hh:mm:ss")
Date.prototype.format = function(format) {
	var o = {
		"M+": this.getMonth()+1, //month 
		"d+": this.getDate(), //day 
		"h+": this.getHours(), //hour 
		"m+": this.getMinutes(), //minute 
		"s+": this.getSeconds(), //second 
		"q+": Math.floor((this.getMonth() + 3) / 3), //quarter 
		"S": this.getMilliseconds() //millisecond 
	}
	if(/(y+)/i.test(format)) {
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	for(var k in o) {
		if(new RegExp("(" + k + ")").test(format)) {
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
}

//时间戳格式化  传参time：指定时间，nowtime:当前时间，10-7
function timeTo(time,nowtime,symbol){
	if(symbol=='年月日'){
		var split = symbol;
	}else{
		var split = symbol ? symbol:'/';
	}
    var date = new Date(time);
    var nowdate =new Date(nowtime);
    var PY = date.getFullYear();//获取指定时间年份
    var NY = nowdate.getFullYear();//获取当前时间年份
    var Y = (symbol=='年月日')? date.getFullYear()+split[0]:date.getFullYear()+split;
    var Ms = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1);
    var M = (symbol=='年月日')? (date.getMonth()+1)+split[1]:Ms+split;
    var Ds = date.getDate()<10 ? '0'+ date.getDate() : date.getDate();
    var D = (symbol=='年月日')? date.getDate()+split[2]:Ds;
    var h = date.getHours() + split;
    var m = date.getMinutes() + split;
    var s = date.getSeconds();
    if(PY==NY){//判断年份是否是同一年，是的输出格式 08/01  不是的话输出格式2018/08/01
    	return M+D;
    }else{
    	return Y+M+D;
    }
}

//对时间戳进行转化，转化成时间统一xxxx-xx-xx 00:00:00
function timeTotime(time) {
    var date = new Date(time);
	var Y = date.getFullYear() + '/';
    var M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '/';
    var D = date.getDate();
    var newtime= Y+M+D+" 00:00:00";
    return new Date(newtime).getTime();
}

/*获取传入时间距离当前时间的天数，然后进行判断，状态分为，如果是同一天显示今天，少一天是昨天，
少两天是前天，超过两天如果在本周显示周几，超过本周显示上周几，超过上周显示真实日期。明天，后天，下周同理。*/
function ifDate(perDate,symbol,nowdate){//10-7
	var weekdays=['','一','二','三','四','五','六','日'];
	if(arguments.length==0){return false;}
	if(typeof(perDate)!='number' && typeof(perDate)!='object' && (typeof(perDate)=='number' && (perDate+'').length!=10 && (perDate+'').length!=14)){return false;}
	if(arguments.length==1 || arguments.length==2){
		nowdate=new Date().getTime();
	}
	if(typeof(perDate)=='number'){
		if((perDate+'').length==10){
			perDate=Number(perDate+'000');
		}
	}else{
		perDate=perDate.getTime();
	}
	var now = timeTotime(nowdate);	//对时间戳进行转化，转化成时间统一xxxx-xx-xx 00:00:00
	var wday =timeTotime(perDate);
	var runTime =(now-wday)/1000;
    var day = Math.floor(runTime / 86400);
    var nowday = new Date(now).getDay();//获取当前时间是星期几，0-6
    if(nowday==0){	//如果为0的话，把周日赋值为7   1-7分别对应周一到周日
    	var nowday =7;
    }
    if(day>=-2 && day<=2){
    	var daystrsarr=['后天','明天','今天','昨天','前天'];
    	return daystrsarr[day+2];
    }else if((Math.abs(day)>(14-nowday) && day<0) || day>=nowday+7){	//判断是否超过下一周，显示正常格式
    	return timeTo(wday,now,symbol);
    }else if(day>=nowday && day<(nowday+7)){	//判断是否是上一周
    	var dayNum=Math.abs(day-nowday-7);
    	return ('上周'+weekdays[dayNum]);
    }else if(day<0 && Math.abs(day)<=(7-nowday) || (day>0 && day<nowday)){	//判断是否是当前周
    	var dayNum =nowday-day;
    	return('本周'+weekdays[dayNum]);
    }else if(day<0 && Math.abs(day)>(7-nowday) && Math.abs(day)<=(14-nowday)){	//判断是否是下一周
    	var dayNum=Math.abs(day)+nowday-7;
    	return('下周'+weekdays[dayNum]);
    }else{
    	return timeTo(wday,now,symbol);
    }
}

//名字改变头像颜色
function todealName(str){
	str=str.replace(/\s/g,'');
	var colors=['#648EC3','#8364C3','#C36468','#64B0C3','#64B0C3','#C38664'];
	if(typeof str=='string'){
		var color=getcolors(str);
		var strname=getname(str);
		return [color,strname];
	}else if(typeof str=='number'){
		var color=getcolors(String(str));
		var strname=getname(str);
		return [color,strname];
	}else{
		return false;
	}
	//计算颜色
	function getcolors(str){
		var num='';
		var strarr=str.split("");
		for(var i=0;i<strarr.length;i++){
			num+=String(strarr[i].charCodeAt());
		}
		return colors[parseInt(num)%(colors.length)]
	}
	//计算字符串
	function getname(str){
		str=str.toUpperCase();
		if(str.length>0){
			if(str.length<2){
				return str;
			}else{
				if(str.match(/[\u4e00-\u9fa5]/g) && str.match(/[\u4e00-\u9fa5]/g).length==str.length){	//全部中文
					return str.substring(str.length-2,str.length);
				}else{
					return str.substring(0,2);
				}
			}
		}else{
			return false;
		}
	}
}
//初始化主图地块
function initareafn(idname,path,center,color,setotionsfn){
	
	if(!idname || !center || !path || path.length==0){return false;}
	try{
		var satelliteMap=L.tileLayer.chinaProvider('Google.Satellite.Map', { maxZoom: 21, minZoom: 5 });
		var options = {
			center:center,
			zoom: 5,
			layers: [satelliteMap],
			zoomControl: false,
			attributionControl:false,
			dragging:false,
			touchZoom:false,
			scrollWheelZoom:false,
			doubleClickZoom:false,
			boxZoom:false,
			tap:false,
			keyboard:false
		}
		if(setotionsfn){
			options = $.extend(true,options,setotionsfn)
		}
		console.log(JSON.stringify(options))
		//初始化地图
		var mymap = L.map(idname,options);
	
	
		var polygon=L.polygon(path,{
	       color: color || '#64C3A4',
	       fillColor: color || '#64C3A4',
	       fillOpacity: 0.5
	    }).addTo(mymap);
		mymap.fitBounds(polygon.getBounds());  //getBounds（获取边界）：返回地图视图的经纬度边界。
	}catch(e){
		//
	}
}

//获取 n位小数
function numTofixed(num,n,per){
	if(num!=0){
		if(arguments.length==3 && per){
			num=num*100;
			return parseInt(num*Math.pow(10,n)+0.5,10)/Math.pow(10,n)+"%"; 
		}else{
			return parseInt(num*Math.pow(10,n)+0.5,10)/Math.pow(10,n); 
		}
	}else{
		if(arguments.length==3 && per){
			return "0%"; 
		}else{
			return 0; 
		}
	}
}

/*---------------------------------------- 菜单权限  start-------------------------------------------*/
//按钮权限 比较
function hasPowerfn(mark,nextfn,regetpower){
	var companyid=0;
	var pageparams = {}
	pageparams.company = $api.getStorage("COMPANYID") ? $api.getStorage("COMPANYID"):"";
	pageparams.farm = $api.getStorage("FARM") ? $api.getStorage("FARM"):"";
	
	if(pageparams && pageparams.company){companyid=pageparams.company;}
	var powerresult;
	regetpower=regetpower||false;
	var allpower=$api.getStorage("ALLPOWER") || false;
	if(allpower){allpower=JSON.parse(allpower);}
	if(allpower && allpower.hasOwnProperty(companyid) && allpower[companyid]['value'] && (allpower[companyid].hasOwnProperty('time') && Date.parse(new Date())<allpower[companyid]['time']+1200000) && !regetpower){
		var btnpower=allpower[companyid]['value'];
		if(mark instanceof String){
			if(btnpower.indexOf('|'+mark+'|')!=-1){	//有权限
				powerresult=true;
				if(mark.hasOwnProperty('domselecter') && $(mark.domselecter).hasClass("hidden")){$(mark.domselecter).removeClass("hidden");}
			}else{	//无权限
				if(mark.hasOwnProperty('domselecter')){
					if(!mark.hasOwnProperty('domsave') || !mark.domsave){
						$(mark.domselecter).remove();
					}
				}
				powerresult=false;
			}
		}
		if(mark instanceof Array){
			var markresult=[];
			for(var i=0;i<mark.length;i++){
				var onestatus=onehaspower(mark[i]);
				markresult.push(onestatus);
			}
			powerresult=markresult;
		}else if(mark instanceof Object){
			var onestatus=onehaspower(mark);
			powerresult=onestatus;
		}
		if(nextfn){nextfn(powerresult);}
		function onehaspower(markobj){
			if(markobj.mark instanceof Array){	//多个权限字符串
				if(!markobj.hasOwnProperty('rules') || markobj.rules==''){markobj.rules=='and';}	//默认and
				var hasboolean=false,result=[];
				for(var k in markobj.mark){
					result.push(btnpower.indexOf('|'+markobj.mark[k]+'|')!=-1);	
				}
				if(markobj['rules']=='or'){
					hasboolean=Boolean(Math.max.apply(null,result));
				}else if(markobj['rules']=='and'){
					hasboolean=Boolean(Math.min.apply(null,result));
				}
				if(!hasboolean){	//无权限
					if(markobj.hasOwnProperty('domselecter')){
						if(!markobj.hasOwnProperty('domsave') || !markobj.domsave){
							$(markobj.domselecter).remove();
						}
					}
				}else{
					if(markobj.hasOwnProperty('domselecter') && $(markobj.domselecter).hasClass("hidden")){$(markobj.domselecter).removeClass("hidden");}
				}
				return hasboolean;
			}else if(typeof(markobj.mark)=='string'){	//权限字符串
				if((btnpower.indexOf('|'+markobj.mark+'|')==-1)){	//无权限
					if(markobj.domselecter){
						if(!markobj.hasOwnProperty('domsave') || !markobj.domsave){
							$(markobj.domselecter).remove();
						}
					}
					return false;
				}else{	//有权限
					if(markobj.hasOwnProperty('domselecter') && $(markobj.domselecter).hasClass("hidden")){$(markobj.domselecter).removeClass("hidden");}
					return true;
				}
			}
		}
		function hasstr(arr,str){
			for(var i=0;i<arr.length;i++){
				if(arr[i]==str){
					return false;
				}
				if(i==arr.length-1){
					return true;
				}
			}
		}
	}else{
		if(nextfn){
			menucontrolfn([mark,nextfn]);
		}else{
			menucontrolfn([mark]);
		}
	}
}
//菜单按钮 权限获取
//1.传companyid 更新 所有权限  2.传数组对象 失效或需要强制刷新时 更新权限
function menucontrolfn(args){
	var args=args;
	var companyId=0;
	if(args instanceof Array){
		var pageparams = {};
		pageparams.company = $api.getStorage("COMPANYID") ? $api.getStorage("COMPANYID"):"";
		pageparams.farm = $api.getStorage("FARM") ? $api.getStorage("FARM"):"";
		if(pageparams && pageparams.company){companyId=pageparams.company;}
	}else{
		companyId=args;
	}
	var allpower=$api.getStorage("ALLPOWER");
	if(allpower){ allpower=JSON.parse(allpower); }
	if(!allpower){	//新登录
		allpower={};
		allpower[companyId]={'value':'','time':0,'getdatatime':0};
	}else if(allpower && !allpower.hasOwnProperty(companyId)){	//新增公司
		allpower[companyId]={'value':'','time':0,'getdatatime':0};
	}
	if(companyId==0){ return false;}
	if(allpower[companyId]['getdatatime']!=0 && allpower[companyId]['getdatatime']+200>Date.parse(new Date())){
		if(args instanceof Array){
			hasPowerfn.apply(null,args);
		}
		return false;
	}
	//重新拉去数据
	var powerGet = getPost({
			"url": urlGetAllPower,
			"params":{"companyId":companyId},
			"noload": true
		});
	powerGet.then(function(resdata) {
		if(resdata){
			allpower[companyId]['value']=JSON.stringify('|'+resdata.obj.permissions.join('|')+'|');
			allpower[companyId]['time']=allpower[companyId]['getdatatime']=Date.parse(new Date());
			$api.setStorage("ALLPOWER",JSON.stringify(allpower));
			if(args instanceof Array){
				hasPowerfn.apply(null,args);
			}
		}
	},function(err){
		console.log('获取权限出错了');
	});
}
/*---------------------------------------- 菜单权限  end-------------------------------------------*/

//指定位置数字替换
function numReplace(num,params){
	var opts = $.extend({
					start:3,
					length:4,
					symbol:'*'
				},params);
	
	if(typeof num != 'String'){
		num = String(num);
	}
	
	var num1 = num.substring(0,opts.start);
	var num2 = num.substring(opts.start+opts.length);
	
	for(var i=0;i<20;i++){
		opts.symbol += opts.symbol;
	}
	
	var num3 = opts.symbol.substr(0,opts.length);
	
	return num1+num3+num2;
}

function numLimitCheck(val,max,len){
	if(!len && typeof(len)=='number'){//判断是0不是空，len为0时则表示限制输入为大于零的正整数
		val = val.replace(/^0|[^\d]+/,'');
		if(val>max){
			var valLen = val.length;
			for(var i = valLen-1;i>=0;i--){
				var subVal = val.substr(0,i);
				if(subVal <= max){
					return subVal;
				}
			}
		}else{
			return val
		}
	}
	
	var saveLen = len? len+1:2;
	val = val.replace(/[^\d.]/g,'');
	var point = val.indexOf(".");
	if(point != -1){
		var cutlen = val.indexOf("..")!=-1 ? point+saveLen-1:point+saveLen;
		val = val.substr(0,cutlen);
	}
	if(val>max){
		var valLen = val.length;
		for(var i = valLen-1;i>=0;i--){
			var subVal = val.substr(0,i);
			if(subVal <= max){
				return subVal;
			}
		}
	}else if(val.substr(0,1)==='0' && val.substr(1,2).indexOf(".")!=-1){
		var patrn = /^[0]{1}(\.\d?)?$/;
		if (!patrn.exec(val)){
			var a2 = val.substr(0,val.length);
	    	return a2;
	  }else{
	    	return val;
	    }
	}else if(val.substr(0,1)==='0' && val.substr(1,2).indexOf(".")==-1){
		var patrn = /^[0]{1}(\.\d?)?$/;
		if (!patrn.exec(val)){
			var a2 = val.substr(0,val.length-1);
	    	return a2;
	  }else{
	    	return val;
	    }
	}else{
		var patrn = /^[1-9]\d*(\.\d?)?$/;
	    if (!patrn.exec(val)){
	    	if(val.length >1){
	    		var a1 = val.substr(0,val.length);
	    		return a1
	    	}else{
	    		return val;
	    	}
	    }else{
	    	return val;
	    }
	}
}
function textlen(str,max) {
	if(arguments.length==0){return false;}
    if(typeof(str)!='string'){
    	var n=str.toString();
    }else{
    	var n=str;
    }
    n=$.trim(n);
    if(arguments.length==1){
    	return getn(n);
    }else{
    	if(n.length>max){
    		var now=0;
        	for(var i=0;i<=n.length;i++){
        		var inn=getn(n.substring(0,i));
        		if(inn>=max){
        			if(inn>max){
        				now=i-1;
        			}else{
        				now=i;
        			}
        			break;
        		}
        	}
        	return now;
    	}else{
    		return max;
    	}
    }
    function getn(n){
        var alllen=n.length;
        if(n.match(/[\u4e00-\u9fa5]/g)){
        	var zhonglen=(n.match(/[\u4e00-\u9fa5]/g)).length;
        }else{
        	var zhonglen=0;
        }
        return ((alllen-zhonglen)/2+zhonglen);
    }
}
function hasitem(arr,item){
	for(var i=0;i<arr.length;i++){
		if(arr[i]==item){
			return true;
		}
	}
	return false;
}
