/* ----------------------------------------------------- 公共变量 接口地址   ----------------------------------------------------- */
var servertype='1';	//0 测试服	1 正式服
var serverHttpobj={
	'0':{	//测试服
		"httpserver":"http://test.snkoudai.com",	
		"uploadServer":'http://test.snkoudai.com/api',	//上传阿里云 接口服务
		"rootServer":'http://showtest.snkoudai.com/suyuan',	//溯源H5
		"iotcompanyarr":["989","817","1109","1484"],
		"iotfarmarr":["1793","1568","1968","2593"]
	},
	'1':{	//正式服
		"httpserver":"http://www.snkoudai.com",
		"uploadServer":'http://www.snkoudai.com/api',	//上传阿里云 接口服务
		"rootServer":'http://show.snkoudai.com/suyuan',	//溯源H5
		"iotcompanyarr":["871","906","1109"],
		"iotfarmarr":["1647","1691","1968"]
	}
}
var iotcompanyarr=serverHttpobj[servertype].iotcompanyarr;
var iotfarmarr=serverHttpobj[servertype].iotfarmarr;

var httpserver = serverHttpobj[servertype].httpserver;
var uploadServer =serverHttpobj[servertype].uploadServer;
var rootServer=serverHttpobj[servertype].rootServer;

//app端上传阿里云
var urlEndpoint = httpserver+'/api/foundation/file/getOssInfo';//获取endpoint和bucketName信息
var urlsignUrl = httpserver+'/api/foundation/file/getSign';//自签名URL地址


//基础设置————农产品模块
var urlAddSingleGood = httpserver +'/api/produce/goods/add';//新增农产品(单个)
var urlAddBatchGood = httpserver +'/api/produce/goods/batch/add';//新增农产品(批量)
var urlDelSingleGood = httpserver +'/api/produce/goods/del';//删除农产品
var urlEditSingleGood = httpserver +'/api/produce/goods/update';//修改农产品
var urlGetGoodsList = httpserver+'/api/produce/goods/list/crop/check';//批量添加农场品时获取的农作物列表
var urlGetTotalGoods = httpserver+'/api/produce/goods/list';//获取农产品列表
var urlGetGoodsById = httpserver+'/api/produce/goods/list/cropid';//根据农作物id获取对应的农产品列表
var urlGetInfoByCrop = httpserver+'/api/produce/crop/get';//根据农作物id获取农作物图片等信息
var urlAddNewCrop = httpserver+'/api/appconfig/crop/feedback/add';//新增作物提交审核

//登录接口
var urlServiceRule = httpserver+'/api/user/agreement/get';//登录页服务条款；
var urlGetImgCode = httpserver+'/api/foundation/validate/code/get';//图片验证码
var urlCheckImgcode = httpserver+'/api/foundation/validate/code/check';//效验图片验证码
var urlSendSmsVcode = httpserver+'/api/foundation/sms/sendSmsVcode';//发送验证码
var urlCheckSmsVcode = httpserver+'/api/foundation/sms/checkSmsVcode';//验证验证码
var urlLoginOut = httpserver+'/api/user/login/logout';//退出登录
var urlLoginPhone = httpserver+'/api/user/login/phone';//用户登录
/*用户和企业*/
var urlListByParentId = httpserver+'/api/foundation/area/listByParentId';//获取省市区下拉
var urlCompanyAdd = httpserver+'/api/user/company/add';//新增企业
var urlCompanyGet = httpserver+'/api/user/company/get';//获取某一企业信息
var urlCompanyEdit = httpserver+'/api/user/company/edit';//修改企业名称
var urlCompanyDel = httpserver+'/api/user/company/del';//删除企业
var urlCompanyQuit = httpserver+'/api/user/user/company/quit';//退出企业
var urlUserGet =httpserver+'/api/user/user/get';//个人信息获取
var urlUserTokenGet =httpserver+'/api/user/user/get/token';	//再登录页 个人信息获取
var urlUserEditPhone =httpserver+'/api/user/user/editPhone';//修改手机号
var ossRequestPath = uploadServer+'/foundation/file/encryptParam';//获取阿里接口
var urlEditHeadUrl = httpserver+'/api/user/user/editHeadUrl';//修改头像
var editContactUrl = httpserver+'/api/user/company/edit/contacttel';//设置客服电话
/*农场详情*/
var addReportUrl = httpserver+'/api/produce/farm/inspect/report/add';//新增检测报告
var reportListUrl = httpserver+'/api/produce/farm/inspect/report/list';//获取农场检测报告列表
var delReportUrl = httpserver+'/api/produce/farm/inspect/report/del';//删除指定农场检测报告
var getReportUrl = httpserver+'/api/produce/farm/inspect/report/get';//获取单个农场检测报告
var editReportUrl = httpserver+'/api/produce/farm/inspect/report/update';//修改单个检测该报告
/*新增地块&&新增物品种类*/
var urlLandAdd = httpserver+'/api/produce/land/add';//新增地块
var urlLandTypeList = httpserver+'/api/produce/land/type/list';//地块类型
var urlLandEdit = httpserver+'/api/produce/land/edit';//修改地块信息
var urlPlantCropList = httpserver+'/api/produce/plant/crop/list';//获取农作物列表
var urlPlantStandardList = httpserver+'/api/produce/plant/standard/list';//获取种植标准
var urlPlantAdd = httpserver+'/api/produce/plant/add';//新增种植计划
/*工作台首页*/
var urlGetStatics = httpserver+'/api/customer/customer/statics';//获取工作台首页统计数据
var urlAccountCompany = httpserver+'/api/user/company/list';//获取用户账号下的所有企业列表
var urlGetFarmList = httpserver+'/api/produce/farm/list';//根据企业id获取企业下所有的农场列表
var urlGetPlotsList = httpserver+'/api/produce/land/list';//根据企业id、农场id获取农场下的地块列表
var urlGetProvinceCity = httpserver+'/api/foundation/area/listByParentId';//获取省市县列表
var urlAddNewFarm = httpserver+'/api/produce/farm/add';//添加一个农场
var urlDelFarmById = httpserver+'/api/produce/farm/del';//删除一个农场
var urlEditFarmById = httpserver+'/api/produce/farm/edit';//编辑一个农场
var urlGetFarmInfo = httpserver+'/api/produce/farm/get';//获取农场详情
var urlDelPlotById = httpserver+'/api/produce/land/del';//工作台首页删除一个地块
/*生产任务模块*/
var urlAddNewTask = httpserver+'/api/produce/mission/add';//新增任务
var urlDelTask = httpserver+'/api/produce/mission/del';//删除任务
var urlEditCompleteTask = httpserver+'/api/produce/mission/edit/complete';//编辑已完成的任务---废弃
var urlEditUncompleteTask = httpserver+'/api/produce/mission/edit/notcomplete';//编辑未完成的任务---废弃
var urlTaskDetailGet = httpserver+'/api/produce/mission/get';//获取某个任务详情
var urlSourceListSelect = httpserver+'/api/produce/agri/res/list/select';//获取农资列表
var urlSourceTypeGet = httpserver+'/api/produce/agri/res/category/list';//获取农资类型
var urlSourceUnitGet = httpserver+'/api/produce/agri/res/unit/list';//获取农资单位
var urlAddNewSource = httpserver+'/api/produce/agri/res/add';//新增一个农资
var urlAddNewGood = httpserver+'/api/produce/mission/input/add';//未完成任务添加一个投入品
/*2018-12-17---查看,编辑任务拆分接口*/
var urlEditTaskTitle = httpserver+'/api/produce/mission/edit/name';//修改任务名称
var urlEditTaskDesc = httpserver+'/api/produce/mission/edit/desc';//修改任务描述
var urlEditTaskcharger = httpserver+'/api/produce/mission/edit/charge/user';//修改任务负责人
var urlEditTaskType = httpserver+'/api/produce/mission/edit/feedback/type';//修改任务反馈类型
var urlEditTaskSTime = httpserver+'/api/produce/mission/edit/start/time';//修改任务开始时间
var urlEditTaskCTime = httpserver+'/api/produce/mission/edit/complete/time';//修改任务完成时间
var urlEditTaskGTime = httpserver+'/api/produce/mission/edit/end/time';//修改任务结束时间
var urlEditTaskAgricul = httpserver+'/api/produce/mission/edit/input';//修改任务投入品，删除任务投入品
var urlEditTaskStatus = httpserver+'/api/produce/mission/edit/status';//修改任务状态
/*地块详情页---任务日历模式、任务列表模式*/
var urlGetPlotsSelect = httpserver+'/api/produce/land/list/select';//地块详情页地块下拉框列表
var urlTaskListMode = httpserver+'/api/produce/mission/list/land/table';//任务列表模式下已完成、未完成列表
var urlEditComTask = httpserver+'/api/produce/mission/edit/complete';//编辑已完成的任务---废弃
var urlEditUncomTask = httpserver+'/api/produce/mission/edit/notcomplete';//编辑未完成的任务---废弃
var urlGetDailyTask = httpserver+'/api/produce/mission/get/date';//获取日历模式下一天的生产任务
var urlTaskPersonList = httpserver+'/api/user/user/company/listInByMission';//添加任务时获取负责人列表
var urlTaskExtroPersonList = httpserver+'/api/user/user/company/listNotInByMission';//添加任务时获取其他农场负责人列表
var urlTaskAddExtroPerson = httpserver+'/api/user/user/company/addFromFarmByMission';//添加任务时添加其他农场负责人
var urlTaskRoleRight = httpserver+'/api/user/role/listByMissionCharge';//添加任务时获取角色权限列表
var urlTaskAddPerson = httpserver+'/api/user/user/company/addByMission';//添加任务时添加一个员工
var urlTaskExport = httpserver+'/api/produce/mission/export';//导出任务列表
var urlGetFileName = httpserver+'/api/produce/mission/export/filename';//获取要导出的excel文件名称
/*地块详情页*/
var urlGetPlotDetail = httpserver+'/api/produce/land/get';//获取地块详情页基本信息
var urlGetPlantPlan = httpserver+'/api/produce/plant/list';//获取地块详情页种植计划列表
var urlDelPlantPlan = httpserver+'/api/produce/plant/del';//删除一个种植计划
var urlClosePlantPlan = httpserver+'/api/produce/plant/over';//结束一个种植计划
var urlGetCropList= httpserver+'/api/produce/plant/crop/list';//获取农作物列表
var urlGetPlantLevelList = httpserver+'/api/produce/plant/standard/list';//获取种植标准列表
var urlSubmitPlantPlan = httpserver+'/api/produce/plant/add';//添加一个种植计划
var urlEditPlantPlan = httpserver+'/api/produce/plant/edit';//编辑一个种植计划
var urlGetPlantPlanInfo = httpserver+'/api/produce/plant/get';//获取一个种植计划详情用于信息回显
var urlHistoryPlantList = httpserver+'/api/produce/plant/list/history';//获取历史种植计划
var urlDateTaskList = httpserver+'/api/produce/mission/list/land/cal';//地块详情页，生产任务日历模式下任务已完成未完成的数据列表
var urlSubmitPlotOutline = httpserver+'/api/produce/land/edit/outline';//修改地块轮廓
var urlRecentlyLand = httpserver+'/api/produce/land/get/recently/added';	//获取最近添加的带有轮廓的地块
/*地块详情页---农资使用记录*/
var urlGetAgriculList = httpserver+'/api/produce/mission/input/list';//获取农资使用记录列表
/*种植计划检测报告*/
var urlReportList = httpserver+'/api/produce/plant/inspect/report/list';//获取检测报告列表
var urlAddreport =httpserver+'/api/produce/plant/inspect/report/add';//添加检测报告
var urlReportUpdate = httpserver+'/api/produce/plant/inspect/report/update';//修改检测报告
var urlDelReport = httpserver+'/api/produce/plant/inspect/report/del';//删除检测报告
var urlRepoerGet = httpserver+'/api/produce/plant/inspect/report/get';//拉取指定报告
/*地块详情页---采收记录*/
var urlGetHarvestList = httpserver+'/api/produce/plant/pickRecord/list';//获取采收记录列表
var urlDelHarvestItem = httpserver+'/api/produce/plant/pickRecord/del';//删除一条采收记录
var urlGetRecordSpecies = httpserver+'/api/produce/plant/pickRecord/land/crop/select';//获取采收记录中的种植品种
var urlHarvestStatisty = httpserver+'/api/produce/plant/pickRecord/land/Statistics';//获取采收记录的统计数据
/*地块详情页---采收弹框*/
var urlPickPersonList = httpserver+'/api/user/user/company/listInByPick';//采收时获取采收负责人列表
var urlPickExtroPersonList = httpserver+'/api/user/user/company/listNotInByPick';//采收时获取其他农场负责人列表
var urlPickAddExtroPerson = httpserver+'/api/user/user/company/addFromFarmByPick';//采收时添加其他农场负责人
var urlPickRoleRight = httpserver+'/api/user/role/listByPickCharge';//采收时获取角色权限列表
var urlPickAddPerson = httpserver+'/api/user/user/company/addByPick';//采收时添加一个员工
var urlAddNewPick = httpserver+'/api/produce/plant/pickRecord/add';//新增一条采收
/* 农产品 */
var urlGoodsList = httpserver+'/api/produce/goods/list';//农产品列表
var urlSelectGood = httpserver+'/api/produce/plant/pickRecord/land/goods/select';	//采收的农产品列表
var urlGetGoodsByCrop = httpserver+'/api/produce/goods/list/cropid';	//根据作物id获取农产品列表
var urlAddSingleGood = httpserver +'/api/produce/goods/add';//新增农产品(单个)
var urlAddBatchGood = httpserver +'/api/produce/goods/batch/add';//新增农产品(批量)
var urlDelSingleGood = httpserver +'/api/produce/goods/del';//删除农产品
var urlEditSingleGood = httpserver +'/api/produce/goods/update';//修改农产品
/*个人中心*/
var urlEditStaffName = httpserver+'/api/user/user/company/editMyName';//编辑个人在企业中的名称
/*员工管理*/
var urlGetListByManage=httpserver+'/api/user/role/listByManage';//角色列表
var urlGetListMyFarm = httpserver+'/api/user/user/company/listMyFarm';//获取用户管理的农场列表
var urlAddCompanyUser = httpserver+'/api/user/user/company/add';//添加员工
var urlCompanyUserList = httpserver+'/api/user/user/company/list';//员工列表
var urlRoleList = httpserver+'/api/user/role/list';//人员权限提示信息
var urlUserCompanyGet = httpserver+'/api/user/user/company/get';//获取其中一个员工信息
var urlEditUserName = httpserver+'/api/user/user/company/editUserName';//修改指定用户姓名
var urlEditUserFarm = httpserver+'/api/user/user/company/editUserFarm';//修改指定用户农场
var urlDeleUser = httpserver+'/api/user/user/company/del';//删除指定员工;
var urlEditUserRole = httpserver+'/api/user/user/company/editUserRole';//修改员工角色;
var urlCompanyTransfer = httpserver+'/api/user/user/company/transfer';//移交企业
/* 客户管理*/
var getCustomerList = httpserver+'/api/customer/customer/list';//获取客户列表
var addCustomer = httpserver + '/api/customer/customer/add';//添加客户
var editCustomer = httpserver + '/api/customer/customer/edit';//编辑基本资料
var delCustomer = httpserver + '/api/customer/customer/del';//删除客户
var getCustomer = httpserver + '/api/customer/customer/get';//获取某个客户资料
var refereeList = httpserver+ '/api/customer/customer/referee/list';//获取推荐人列表
var getAddressList = httpserver +'/api/customer/customer/address/list';//获取收货地址列表
var addAddress = httpserver + '/api/customer/customer/address/add';//添加收货地址
var delAddress = httpserver + '/api/customer/customer/address/del';//删除收货地址
var editAddress = httpserver + '/api/customer/customer/address/edit';//编辑收货地址
var setDefault = httpserver + '/api/customer/customer/address/setDefault';//设为默认地址
var getComboList = httpserver +'/api/customer/customer/customerPackage/list';//获取宅配套餐列表
var addCombo = httpserver +'/api/customer/customer/customerPackage/add';//添加宅配套餐接口
var editCombo = httpserver + '/api/customer/customer/customerPackage/edit';//修改宅配套餐接口
var delCombo = httpserver + '/api/customer/customer/customerPackage/del';//删除宅配套餐接口
var selectCombo = httpserver +'/api/customer/package/listByCustomer';//用于套餐管理宅配下拉框
var editComboNumber = httpserver + '/api/customer/customer/customerPackage/editCanNumber';//修改套餐剩余配送次数
var listInBySell = httpserver + '/api/user/user/company/listInBySell';//获取销售人员列表
var addBySell = httpserver + '/api/user/user/company/addBySell';//添加销售人员
var orderrecondList = httpserver + '/api/customer/order/listByCustomer';	//下单记录列表接口
/*任务*/
var urlTotalTask = httpserver+'/api/produce/mission/list';//获取所有任务，app端使用
var urlListLately = httpserver+'/api/produce/mission/list/mission/lately';//获取近期任务
var urlListMyCharge = httpserver+'/api/produce/mission/list/my/charge';//所有任务-我负责的
var urlListMyCreate = httpserver+'/api/produce/mission/list/my/create';//所有任务-我创建的
var urlListMyInvolve = httpserver+'/api/produce/mission/list/my/involve';//所有任务-我参与的
var urlMissionFeedback = httpserver+'/api/produce/mission/feedback';//完成任务
var urlDelayCount = httpserver+'/api/produce/mission/delay/count';//任务红点
/*订单管理*/
var urlListByCommonOrder = httpserver+'/api/customer/customer/customer/listByCommonOrder';//订单获取客户列表
var urlAddressList = httpserver+'/api/customer/customer/address/list';//获取客户地址
var urlAddAdress = httpserver+'/api/customer/customer/address/add';//添加收货地
var urlAddOrder = httpserver+'/api/customer/order/add';//添加普通订单;
var urlAllOrderList = httpserver+'/api/customer/order/all/list';//全部订单列表
var urlAllOrderList2 = httpserver+'/api/customer/order/all/list2';//全部订单列表(可以获取菜品)
var urlComOrderList = httpserver+'/api/customer/order/delivery/list';//宅配订单列表
var urlCommonnodeliveryList = httpserver+'/api/customer/order/commonnodelivery/list';//普通订单待发货
var urlCommondeliveriedList = httpserver+'/api/customer/order/commondeliveried/list';//普通订单已发货
var urlComGoodsGet = httpserver+'/api/customer/order/common/goods/get';//普通订单菜品列表
var urlDeliGoodsGet = httpserver+'/api/customer/order/delivery/goods/get';//宅配订单菜品列表
var urlOrderDelivery = httpserver+'/api/customer/order/delivery';//订单发货
var urlOrderCancel = httpserver+'/api/customer/order/cancel';//取消订单发货
var urlComOrderGet = httpserver+'/api/customer/order/get';//拉取单个普通订单信息
var urlDeleOrder = httpserver+'/api/customer/order/del';//删除订单接口
var urlEditComOrder = httpserver+'/api/customer/order/edit';//修改普通订单接口
var urlEditDeliveryOrder = httpserver+'/api/customer/order/delivery/edit';//修改宅配订单接口
var urlOrderAllStatics = httpserver+'/api/customer/order/allStatics';//当日菜品统计
var urlOrderExport = httpserver+'/api/customer/order/all/export';//导出全部订单
var urlOrderBatchDelivery = httpserver+'/api/customer/order/batchDelivery';//批量发货
var urlOrderBatchCancel = httpserver+'/api/customer/order/batchCancel';//批量取消发货
/*基础设置*/
var urlAddPackageGroup = httpserver + '/api/customer/package/group/add';//添加套餐组
var urlPackageGroupDel = httpserver +'/api/customer/package/group/del';//删除套餐组
var urlPackageAdd = httpserver + '/api/customer/package/add';//添加套餐
var urlPackageEdit = httpserver + '/api/customer/package/edit';   //修改套餐
var urlPackageDel = httpserver + '/api/customer/package/del';  //  删除套餐
var urlPackageGroupList = httpserver + '/api/customer/package/group/list';
var urlPackageGet = httpserver + '/api/customer/package/get';
var urlPackageGroupEdit = httpserver + '/api/customer/package/group/edit';
var urlAgriResUnitList = httpserver + '/api/produce/agri/res/list/select'; // 农资单位
// 农资
var urlAgriResAdd = httpserver + '/api/produce/agri/res/add'; // 添加农资
var urlAgriResCategoryList = httpserver + '/api/produce/agri/res/category/list'; // 获取农资分类
var urlAgriResDel = httpserver + '/api/produce/agri/res/del'; // 删除农资
var urlAgriResEdit = httpserver + '/api/produce/agri/res/edit'; // 修改农资
var urlAgriResGet = httpserver + '/api/produce/agri/res/get'; // 农资详情
var urlAgriResList = httpserver + '/api/produce/agri/res/list'; // 农资列表
var urlAgriResListSelect = httpserver + '/api/produce/agri/res/list/select'; // 农资下拉框
var urlAgriResUnitList = httpserver + '/api/produce/agri/res/unit/list'; // 农资单位
// 会员管理
var urlCustomerListByPackage = httpserver + '/api/customer/customer/customer/listByPackage' // 基础数据--宅配套餐--列表--管理会员--列表
//urlGetCustomerList = httpserver + '/api/customer/customer/list'    // 获取客户列表
/*权限按钮*/
var urlGetAllPower=httpserver+'/api/user/role/permissions';
//宅配计划
var urlSetCustomTime = httpserver + '/api/customer/deliveryplan/setOrderTime';//设定默认下单开始、截止时间
var urlGetCustomTime = httpserver + '/api/customer/deliveryplan/getOrderTime';//获取上一次设定的默认下单开始、截止时间
var urlEditCustomTime = httpserver + '/api/customer/deliveryplan/editOrderTime';//修改默认下单开始、截止时间（非第一次设置）
var urlGetMemberCard = httpserver + '/api/customer/package/group/list';//获取会员套餐
var urlAddMemberCard = httpserver + '/api/customer/package/group/add';//添加一个会员套餐
var urlGetSettedTime = httpserver + '/api/customer/deliveryplan/get';//获取宅配计划的时间
var urlEditSettedTime = httpserver + '/api/customer/deliveryplan/edit';//修改宅配计划的时间
var urlSubmitAddPlan = httpserver + '/api/customer/deliveryplan/add';//新增一个宅配计划
var urlPlanRepeatCheck = httpserver + '/api/customer/deliveryplan/checkRePeat';//添加宅配计划进入第三步时检测是否重复
var urlHomeDeliveryList = httpserver + '/api/customer/deliveryplan/list';//获取当前、历史宅配计划列表
var urlGetCustomersByPlan = httpserver + '/api/customer/customer/customer/listByDeliveryOrder';//宅配计划-手动添加订单-客户下拉列表
var urlMenberCardByCustomer = httpserver + '/api/customer/customer/customerPackage/listByDeliveryOrder';//宅配计划-手动添加订单-根据客户id获取套餐列表
var urlGetFreeMenu = httpserver + '/api/customer/deliveryplan/freegoods/getByOrder';//获取自由搭配
var urlGetFixedMenu = httpserver + '/api/customer/deliveryplan/fixgoods/getByOrder';//获取固定搭配
var urlDelDeliveryItem = httpserver + '/api/customer/deliveryplan/del';//删除一条宅配计划
var urlDeliveryStatistic = httpserver + '/api/customer/deliveryplan/goodsStatics/get';//统计配送日下单菜品
var urlGetDeliveryInfo = httpserver + '/api/customer/deliveryplan/get';//修改宅配时间时先获取某个宅配计划详情
var urlCloneDelivery = httpserver +'/api/customer/deliveryplan/copy';//复制宅配计划
var urlTimeEditDelivery = httpserver +'/api/customer/deliveryplan/edit';//修改宅配计划时间
var urlGetUpLimitList = httpserver +'/api/customer/deliveryplan/setMaxNum/list';//获取设置菜单上限列表
var urlSubmitUpLimit = httpserver +'/api/customer/deliveryplan/setMaxNum/edit';//提交设置菜品上限列表
var urlSubmitManaulOrder = httpserver +'/api/customer/order/delivery/add';//提交手动添加客户订的数据
var urlGetFixCrop = httpserver + '/api/customer/deliveryplan/fixgoods/get';//查询固定搭配菜单，用于修改菜单数据回显
var urlAddMenuToFix = httpserver + '/api/customer/deliveryplan/fixgoods/addMenu';//修改固定搭配，添加菜单
var urlDelMenuToFix = httpserver + '/api/customer/deliveryplan/fixgoods/delMenu';//修改固定搭配，删除菜单
var urlAddCropToFix = httpserver + '/api/customer/deliveryplan/fixgoods/add';//修改固定搭配，添加菜品
var urlDelCropToFix = httpserver + '/api/customer/deliveryplan/fixgoods/del';//修改固定搭配，删除菜品
var urlGetFreeCrop = httpserver + '/api/customer/deliveryplan/freegoods/get';//查询自由搭配菜单，用于修改菜单数据回显
var urlEditRuleToFree = httpserver + '/api/customer/deliveryplan/freeGoods/editChooseType';//修改自由搭配选菜规则
var urlAddCropToFree = httpserver + '/api/customer/deliveryplan/freegoods/add';//修改自由搭配，添加菜品
var urlDelCropToFree = httpserver + '/api/customer/deliveryplan/freegoods/del';//修改自由搭配，删除菜品
var urlGetTotalPlanCount = httpserver + '/api/customer/deliveryplan/getPlanCount';//获取宅配计划数量，用于页面跳转判断
/*打印溯源*/
var urlGetRootcon = httpserver + '/api/produce/qrcode/H5/get';	//H5页面获取农场企业信息
var urlAddRootTask = httpserver + '/api/produce/qrcode/mission/add';	//添加溯源码任务
var urlGetRootTask = httpserver + '/api/produce/qrcode/mission/list';	//任务时间轴
var urlEditRootShow = httpserver + '/api/produce/qrcode/qrcode/module/edit';	//修改溯源码可访问模块
var urlRespInfo = httpserver + '/api/produce/qrcode/get/resp/info';		//获取溯源码信息
/*订单*/
var urlOrderCheck = httpserver + '/api/customer/order/listByDeliveryPlan';//宅配订单-查看订单
var urlOrderDel = httpserver + '/api/customer/order/del';//宅配订单-删除订单
var urlOrderEdit = httpserver + '/api/customer/order/delivery/edit';//宅配订单-修改订单
/*地图首页*/
var urlMapHome = httpserver + '/api/produce/farm/get/map';//获取农场地图信息
/*物联网*/
var urlGetSensorList = httpserver + '/api/produce/iot/sensor/list';//获取传感器列表数据
var urlGetSebsorHistory = httpserver + '/api/produce/iot/sensor/history';//获取传感器历史数据

var urlIotConfigListlByFarmid = httpserver + '/api/produce/iot/farm/config/list';// 通过farmid获取该农场的物联网设备列表
var urlGetSensorListByFarmid = httpserver + '/api/produce/iot/sensor/list/farm';//通过farmid获取传感器数据（环境监测）


/* 收入 */
var urlIncomeStatics = httpserver + '/api/customer/customer/income/todayAndTomorrow/statics';	//客户当天和昨天的收入/退款/销售额/续费额统计
var urlIncomeListByDay = httpserver + '/api/customer/customer/income/farmIncomeStatics/listByDay';		//农场收入明细(按天)接口
var urlIncomeListByWeek = httpserver + '/api/customer/customer/income/farmIncomeStatics/listByWeek'		//农场收入明细(按周)接口
var urlIncomeListByMonth = httpserver + '/api/customer/customer/income/farmIncomeStatics/listByMonth'		//农场收入明细(按月)接口
var urlIncomeConsumeAmountRecord = httpserver + '/api/customer/customer/income/consumeAmountRecord/List'		//根据日期查询明细接口
var urlCustomerStatics = httpserver + '/api/customer/customer/statics'		//客户统计接口

/* 订单 */ 


/* ----------------------------------------------------- lostorage变量  ----------------------------------------------------- */
//STATUSSH 状态栏 高度
//ACCESSTOKEN 
//LANDSCAPEFZ	横屏字体大小
//VERTICALFZ	竖屏幕字体大小
//NETWORK       网络状态
//UPDATEHELP	版本更新提示时间
//ISLATESTVERSION   是否为最新版本


