
var sensoreffect={
	videolist:[],
	sensorlist:[],
	initInterval:function(videoData,sensorData,weatherData){
		//视频监控
		sensoreffect.videolist.length = 0;
		videoData.forEach(function(item,index){
			sensoreffect.addmark({
				src:"../../image/map/icon_video2.png",
				latlng:[item.lat,item.lng],
				type:'video',
				index:index
			});
			var obj = {
				"name":item.pointName,
				"videohref":item.hlsUrl,
				"latlng":[item.lat,item.lng]
			}
			sensoreffect.videolist.push(obj);
			maphome.copyVideolist.push(obj);
		})
		//环境监测
		sensorData.forEach(function(item,index){
			sensoreffect.addmark({
				src:"../../image/map/icon_sensor2.png",
				latlng:[item.lat,item.lng],
				type:'sensor',
				index:index
			});
		})
		//气象站
		weatherData.forEach(function(item,index){
			sensoreffect.addmark({
				src:"../../image/map/icon_weather2.png",
				latlng:[item.lat,item.lng],
				type:'weather',
				index:index
			});
		})
	},
	addmark:function(mark){
		var greenIcon = L.icon({
			iconUrl: mark.src,
			iconSize: [26, 26],
			type:mark.type,
			className:mark.type+'_marker markitem',
			index:mark.index
		});
		L.marker({lat:mark.latlng[0],lng:mark.latlng[1]}, {
			icon: greenIcon
		}).addTo(maphome.map).on('click', function(e) {
			console.log('执行了')
			maphome.syncAreaSelectfn([],true);
			var type=e.sourceTarget.options.icon.options.type;
			var markindex=e.sourceTarget.options.icon.options.index;
			var ml=($(e.target._icon).offset().left)*2-$(window).width()+16;
			var mt=($(e.target._icon).offset().top)*2-$(window).height()+16;
			sensoreffect.initmarklayer(type,markindex,e.target._icon,e.latlng);
			sensoreffect.backmarkericon(type,e.target._icon);
		})
	},
	weather:function(){
		maphome.toggleModule(5);
		$(".weatherdetail .wrapper .weathercon").append('<div class="weather_items"><div class="weatheritem"><p>风向</p><p class="value">西北</p></div><div class="weatheritem"><p>风速</p><p class="value">0.16m/s</p></div><div class="weatheritem"><p>光照度</p><p class="value">3.67Lux</p></div><div class="weatheritem"><p>空气湿度</p><p class="value">87.96%</p></div><div class="weatheritem"><p>空气温度</p><p class="value">11.63℃</p></div><div class="weatheritem"><p>PM2.5</p><p class="value">65ug/m3</p></div><div class="weatheritem"><p>大气压力</p><p class="value">600mbar</p></div><div class="weatheritem"><p>降水量</p><p class="value">0mm/min</p></div></div>');
	},
	videomonitor:function(dataindex){
		if(sensoreffect.videolist.length==0){
			//这里为了修改莫名产生的bug（videolist会突然置空数组-偶发）
			maphome.copyVideolist.forEach(function(item,index){
				sensoreffect.videolist.push(item);
			})
		}
		maphome.toggleModule(3);
		$(".mapcontent .model-title span.videoname").html(sensoreffect.videolist[dataindex]['name']);
		sensoreffect.initvideo(sensoreffect.videolist[dataindex].videohref,dataindex);
	},
	initvideo:function(href){
		var isVideoBreak;
		videoinit(href);
		//初始化 视频
		function videoinit(href){
			//销毁之前视频
			winvideos && winvideos.dispose();
			//填充dom
			var connectionType = api.connectionType;
			var remfz = $api.getStorage("VERTICALFZ");
			$(".mapcontent .videodetail .videocon").html('<div class="videoitem"><video id="videoitem" class="video-js vjs-default-skin" poster="http://zuoan-test.oss-cn-hangzhou.aliyuncs.com/zuoan-test/snkoudai/B4CEEBF617CDCE7E66EF71B8851AA054.jpg" playsInline webkit-playsinline  autoplay data-setup="{}" width="'+parseInt(7.1*remfz)+'" height="'+parseInt(4.25*remfz)+'"><source src="'+href+'" type="application/x-mpegURL" /></video></div>');
			var myPlayer = videojs('videoitem',{
		        bigPlayButton : false,
		        textTrackDisplay : false,
		        posterImage: true,
		        errorDisplay : false,
		        controlBar : false
		    },function(){
		        this.on('firstplay',function(){
		            console.log('firstplay')
		        })
		        this.on('pause',function(){
		            console.log('pause')
		        })
		        this.on('play',function(){
		            console.log('play')
		        })
		        this.on('seeked',function(){
		        	
		        })
		    }).ready(function(){
		        myPlayer = this;
		    });
		    winvideos=myPlayer;
		    startVideo();
		    function startVideo() {
		        myPlayer.play();
		        //判断开始播放视频，移除高斯模糊等待层
		        var isVideoPlaying = setInterval(function(){
		            var currentTime = myPlayer.currentTime();
		            if(currentTime > 0){
		                $('.vjs-poster').remove();
		                clearInterval(isVideoPlaying);
		            }
		        },200)
		        //判断视频是否卡住，卡主3s重新load视频
		        var lastTime = -1,tryTimes = 0;
		        clearInterval(isVideoBreak);
		        isVideoBreak = setInterval(function(){
		            var currentTime = myPlayer.currentTime();
		            if(currentTime == lastTime){
		            	//此时视频已卡主3s
		            	//设置当前播放时间为超时时间，此时videojs会在play()后把currentTime设置为0
		                myPlayer.currentTime(currentTime+10000);
		                myPlayer.play();
		                //尝试5次播放后，如仍未播放成功提示刷新
		                if(++tryTimes > 5){
		                    myPlayer.currentTime(0);
		                    tryTimes = 0;
		                }
		            }else{
		                lastTime = currentTime;
		                tryTimes = 0;
		            }
		        },3000)
		    }
		}
	},
	sensormonitor:function(){
		maphome.toggleModule(4);
		sensoreffect.getsensorlist(function(htmlstr,sensorlist){
			$(".mapcontent .sensordetail .model-title p.title").removeClass("hidden");
			$(".mapcontent .sensordetail .model-title p.subtitle").addClass("hidden");
			$(".mapcontent .sensordetail .sensormonitor .sensorlist").html(htmlstr);
			$(".mapcontent .sensordetail .model-title p.title").html('<span>传感器</span><i class="pointer"></i><span>'+sensorlist.length+'个</span>');
			//初始化滚动条
			//new BScroll(".sensormonitor .sensorlist",{ scrollY: true, click: true, bounce:false, swipeTime:1000,scrollbar:true})
			$(".sensormonitor .sensorlist").niceScroll({
				cursorcolor:"rgba(0, 23, 17, 0.8)",
				cursorwidth: "2px",
				cursorborder:'none',
				autohidemode:true,
				railoffset:true,
				railpadding: { top:0, right:2, left: 0, bottom:0}
			});
			//绑定事件
			if(sensorlist.length>1){
				$(".sensormonitor .sensorlist ul").on('click','li .sensorlicon',function(){
					var liitem=$(this).closest("li");
					if(liitem.hasClass("active")){
						liitem.removeClass("active").siblings('li').removeClass("active").show();
						liitem.find(".sensor_history").html('<div class="historycon"></div>');
						//滚动条还原
						var ulscrollT=liitem.closest('.sensorlist').data("scrollT");
						$(".sensormonitor .sensorlist").scrollTop(Math.abs(ulscrollT));
						$(".mapcontent .sensordetail .model-title p.title").removeClass("hidden");
						$(".mapcontent .sensordetail .model-title p.subtitle").addClass("hidden");
					}else{
						//记录滚动条位置
						var ulscrollT=liitem.closest('.sensormonitor .sensorlist').scrollTop();
						liitem.closest('.sensorlist').data("scrollT",ulscrollT);
						//隐藏其他，展开显示
						$(".sensormonitor .sensorlist").getNiceScroll().hide();
						liitem.addClass("active").siblings('li').removeClass("active").hide();
						sensoreffect.inithistory(liitem.find(".historycon"),sensorlist[liitem.index()]);
						$(".mapcontent .sensordetail .model-title p.title").addClass("hidden");
						$(".mapcontent .sensordetail .model-title p.subtitle").removeClass("hidden");
					}
				})
			}else if(sensorlist.length==1){
				//隐藏其他，展开显示
				$(".sensormonitor .sensorlist").getNiceScroll().hide();
				$(".sensormonitor .sensorlist ul li").addClass("active").siblings('li').removeClass("active").hide();
				sensoreffect.inithistory($(".sensormonitor .sensorlist ul li").find(".historycon"),sensorlist[0]);
				$(".sensormonitor .sensorlist ul li span.splitline,.sensormonitor .sensorlist ul li .senhistory_btn").remove();
				$(".sensormonitor .sensorlist ul li .sensoritem").css("width",'6.1rem');
			}
		})
	},
	getsensorlist:function(nextfn){	//获取离子列表
		getPost({
			"url":urlGetSensorListByFarmid,
			"params":{"farmId": $api.getStorage("FARMID")},
			"notoken":true,
			"noload":true,
			"successfn":function(res){
				if(res.respCode == 0) {
					var sensorlist=res.obj.sensorDeviceList;
					sensoreffect.sensorlist=sensorlist.concat();
					var html='<ul class="clearfix">';
					var numjson={'0':'<span class="iconfont">&#xe63e;</span>','1':'<span class="iconfont">&#xe645;</span>','2':'<span class="iconfont">&#xe63f;</span>','3':'<span class="iconfont">&#xe644;</span>','4':'<span class="iconfont">&#xe648;</span>','5':'<span class="iconfont">&#xe649;</span>','6':'<span class="iconfont">&#xe646;</span>','7':'<span class="iconfont">&#xe647;</span>','8':'<span class="iconfont">&#xe64b;</span>','9':'<span class="iconfont">&#xe64a;</span>','.':'<span class="iconfont" style="margin:0 0.04rem 0 -0.03rem;vertical-align: -0.24rem;">.</span>'}
					for(var i=0;i<sensoreffect.sensorlist.length;i++){
						var numstr=sensoreffect.sensorlist[i]['data']+'';
						
						var numarr=String(sensoreffect.numTofixed2(numstr,1)).split('');
						//var numarr=numstr.split('');
						html+='<li><div class="sensorlicon clearfix">'+
							'<div class="sensoricon"><img style="margin-top:-2px;" src="../../image/sensor_icon/'+sensoreffect.sensorlist[i]['sensorTypeID']+'.png" alt=""></div>'+
							'<div class="sensoritem">'+
							'<p>'+sensoreffect.sensorlist[i]['deviceName']+'</p>'+
							'<p>单位：<span>'+(sensoreffect.sensorlist[i]['unit']?sensoreffect.sensorlist[i]['unit']:'无')+'</span></p>';

						if(sensoreffect.sensorlist[i]['data']||sensoreffect.sensorlist[i]['data']==0){
							html += '<div class="sensornum za_number" num="'+numstr+'">';
							for(var j=0;j<numarr.length;j++){
								html+=numjson[numarr[j]];
							}
						}else{
							html+='<div class="outline">离线';
						}
						
						html+='</div></div><div class="senhistory_btn"></div><span class="splitline"></span></div><div class="sensor_history"><div class="historycon"></div></div></li>'
					}
					html+='</ul>';
					//渲染弹框
					nextfn(html,sensorlist);
				}
			}
		})
	},
	numTofixed2:function(num,n){
		if(String(num).indexOf('.')!=-1){
			num = String(num).split('.')[0]+'.'+(String(num).split('.')[1]).substring(0,n);
			if(num==parseInt(num)){		//比如19.0要写成19
				num = parseInt(num)
			}
		}
		return num;
	},
	backmarkericon:function(type,imgobj){
		$(".layui-layer-setwin").remove();
		$("#mapcontain .leaflet-map-pane .leaflet-marker-pane img.sensor_marker").attr("src","../../image/map/icon_sensor2.png");
		$("#mapcontain .leaflet-map-pane .leaflet-marker-pane img.video_marker").attr("src","../../image/map/icon_video2.png");
		$("#mapcontain .leaflet-map-pane .leaflet-marker-pane img.weather_marker").attr("src","../../image/map/icon_weather2.png");
		if(arguments.length==2){
			if(type=='sensor'){
				imgobj.src="../../image/map/icon_sensor1.png";
			}else if(type=='video'){
				imgobj.src="../../image/map/icon_video1.png";
			}else if(type=='weather'){
				imgobj.src="../../image/map/icon_weather1.png";
			}
		}
	},
	initmarklayer:function(type,markindex,imgobj,latlng){
		console.log('type:'+type)
		if(arguments.length==4){
			if(type=='sensor'){
				sensoreffect.sensormonitor();
				if(latlng){ maphome.mapMovePos(false,latlng,6); }
			}else if(type=='video'){
				sensoreffect.videomonitor(markindex);
				if(latlng){ maphome.mapMovePos(false,latlng,5.5); }
			}else if(type=='weather'){
				sensoreffect.weather();
				if(latlng){ maphome.mapMovePos(false,latlng,8.8); }
			}
		}
	},
	inithistory:function(ele,sensordata){
		var dom=ele;
		dom.html('<div class="loader historyload"><div class="loader-inner ball-spin-fade-loader"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div></div>');
		if(!window.echarts){
			console.log('加载echarts');
			$.getScript('../../script/echarts.min.js',function(){
				postHistory();
			})
		}else{
			postHistory();
		}
		function postHistory(){
			//获取离子列表
			getPost({
				"url":urlGetSebsorHistory,
				"params":{"deviceId":sensordata.deviceID,"slotId":sensordata.slotID,"farmId": $api.getStorage("FARMID")},
				"notoken":true,
				"noload":true,
				"successfn":function(res){
					var list=res.obj.dataList;
					var xdata=[];
					var ydata=[];
					if(list.length>0){
						for(var i=0;i<list.length;i++){
							xdata.push(new Date(list[i]['time']).format('MM.dd hh:mm'));
							ydata.push(list[i]['close']);
						}
						echartfn(res.obj.unit,xdata,ydata,dom.get(0));
					}else{
						dom.html('<div class="noEchartBox">暂无历史数据</div>')
					}

					
				}
			})
		}
		//echart 表格初始化
		function echartfn(danwei,time,lizidata,domobj){
			if(!domobj){return false;}
			var myChart = echarts.init(domobj);
			var option = {
				title: { show: false, text: '', subtext: '' },
				tooltip: {
					show: true,
					trigger: 'axis',
					borderColor: '#308A6E',
					backgroundColor: "#64C3A4",
					padding: [5, 10, 2],
					textStyle: {
						color: '#fff'
					},
					formatter: function(a) {
						return "<p style='text-align:center;line-height:0.3rem;font-size:0.25rem;'>" + a[0].name + "<br/>数值：" + a[0].value + "</p>"
					},
					axisPointer: {
						lineStyle: {
							color: '#6ffb70',
							width: 1
						},
						crossStyle: {
							color: '#308A6E',
							width: 3
						}
					}
				},
				legend: { data: [] },
				toolbox: { show: false },
				calculable: false,
				xAxis: [{
					type: 'category',
					boundaryGap: false,
					data: time,
					splitLine: { show: false },
					axisLabel: { show: true, textStyle: { color: '#73867A' }, formatter:function(a){ return a.split(' ')[0]+'\n'+a.split(' ')[1]; } },
					axisLine: { lineStyle: { color: '#308A6E', width: 1 } }
				}],
				yAxis: [{ type: 'value', splitLine: { show: true, lineStyle: { color: 'rgba(48,138,110,0.2)' } }, axisLabel: { show: true, textStyle: { color: '#73867A' } }, axisLine: { lineStyle: { color: '#308A6E', width: 1 } } }],
				grid: { x: 50, y: 20, x2: 10, y2: 40, borderWidth: 0 },
				series: [{ name: '传感器历史数据', type: 'line', smooth: true, clickable: false, itemStyle: { normal: { color: '#64C3A4', lineStyle: { color: '#64C3A4' }, areaStyle: { color: 'rgba(109, 250, 115, 0.1)' } }, emphasis: { lineStyle: { color: '#fff' } } }, data: lizidata, symbol: 'circle', symbolSize: 0 }]
			};
			myChart.setOption(option);
		}
	}
}